/*
    Solutie O(n*vmax)
    Recursie cu memoizare
    prof. Constantin Galatan
*/
#include <fstream>

std::ifstream fin("ecluze.in");
std::ofstream fout("ecluze.out");

int Nr(int i, int tr);
void Read();

const int MaxN = 50001, MaxT = 1001;
int n, a[MaxN];
int nr[MaxN][MaxT];

int main()
{
	Read();
	fout << Nr(0,0) << '\n';
	fin.close();
	fout.close();
}

int Nr(int i, int tr) // transport
{
	int& r = nr[i][tr];
	if ( r ) return r;
	if (i == n - 1) return 0;

	if (!tr) tr = a[i];
    if (tr == a[i + 1])
        return r = Nr(i + 1, 0);
    return r = 1 + std::min(Nr(i + 1, 0), Nr(i + 1, tr));
}

void Read()
{
	fin >> n;
	for (int i = 0; i < n; ++i)
		fin >> a[i];
	fin.close();
}
