//prof.Eugen Nodea

# include <fstream>
# include <algorithm>
# define inf 999999999
# define NM 305
using namespace std;

ifstream f("insula.in");
ofstream g("insula.out");

int i, j, n, m, Min1;
int a[NM][NM], cost[NM][NM], Min[NM];

void init ()
{
    for (int i=1; i<=n+1; ++i)
    {
        Min[i] = inf;
        for (int j=1; j<=m; ++j)
            a[i][j] = inf;
    }
}

int main ()
{
    f >> n >> m;
    for (i=1; i<=m; ++i)
        for (j=1; j<=n; ++j)
            f >> cost[i][j+1];

    //cost[i][j]- costul pentru a merge cu transportatorul i in j
    //a[i][j]   - costul minim pt a ajunge la a i-a statie cu transportatorul j

    init ();
    for (i=1; i<=m; ++i)
    {
        if (i == 1) a[2][i] = cost[i][2];
               else a[2][i] = cost[i][2] * 2;
        Min[2] = min(Min[2], a[2][i]);
    }
    for (i=3; i<=n+1; ++i)
    {
        for (j=1; j<=m; ++j)
        {
            a[i][j] = min(a[i-1][j] + cost[j][i], Min[i-1] + 2 * cost[j][i]);
             Min[i] = min(Min[i], a[i][j]);
        }
    }

    Min1 = Min[n+1];

    init ();
    for (i=1; i<=m; ++i)
    {
         if (i == 1) a[n][i] = cost[i][n+1];
                else a[n][i] = cost[i][n+1] * 2;
        Min[n] = min(Min[n], a[n][i]);
    }

    for (i=n-1; i>=1; --i)
    {
        for (j=1; j<=m; ++j)
        {
            a[i][j] = min(a[i+1][j] + cost[j][i+1], Min[i+1] + 2 * cost[j][i+1]);
             Min[i] = min(Min[i], a[i][j]);
        }
    }

    g << min(Min1, Min[1]) << "\n";

    return 0;
}
