/*
    ecluze - O(n * max(h[i])) - amortizat - 90 p.
    prof. Eugen Nodea
*/
# include <fstream>
# include <algorithm>
# define NM 100005
# define NK 1001
# define inf 999999999
using namespace std;

ifstream f("ecluze.in");
ofstream g("ecluze.out");

int i, j, n, m, Inou, I, k, Min, Min2;
int a[NM], ap[NK], cost[NM], v[NM];

void procesare ()
{
    int i;
    for (i=1; i<=NK; ++i)
        if (ap[i])
        {
            ++k;
            ap[i] = k;
        }

    for (i=1; i<=n; ++i)
        a[i] = ap[a[i]];
}
int main ()
{
    f >> n;
    for (i=1; i<=n; ++i)
    {
        f >> a[i];
        ap[a[i]] = 1;
    }

    procesare ();

    for (i=1; i<=k; ++i)
        cost[i] = inf;

    cost[a[1]] = 0;
    Min = 0; v[++I] = a[1];
    // cost[i] = costul minim de a aduce pozitia la costul i
    for (i=2; i<=n; ++i)
    {
        Min2 = inf;
        if (cost[a[i]] == inf) v[++I] = a[i];
        for (j=1; j<=I; ++j)
        {
            if (a[i] == v[j])   //aduc ant la valoarea actuala
                cost[v[j]] = min(Min+1, cost[v[j]]);
            else                //mut actuala la alta valoare
                ++cost[v[j]];
            Min2 = min(Min2, cost[v[j]]);
        }
        Inou = 0;
        for (j=1; j<=I; ++j)
            if (cost[v[j]] == Min2)  v[++Inou] = v[j];
                               else cost[v[j]] = inf;
        I = Inou; Min = Min2;
    }

    g << Min << "\n";

    return 0;
}
