/* Solutie O(n)
   prof. Constantin Galatan
*/
#include <fstream>
#include <vector>
#include <algorithm>

using VI = std::vector<int>;

VI a, b, cnt, pos, sc, nr;
int n, vmax;

int main()
{
    std::ifstream fin("ecluze.in");
    std::ofstream fout("ecluze.out");

	fin >> n;
	a = b = cnt = sc = nr = VI(n);
	for (int i = 0; i < n; ++i)
    {
		fin >> a[i];
		vmax = std::max(vmax, a[i]);
    }

    pos = VI(vmax + 1, -1);
    fin.close();

	b[0] = a[0];
	int k = 1;
	for (int i = 1; i < n; ++i)
		if (a[i] != b[k - 1] )
			b[k++] = a[i];
		else
			cnt[k - 1]++; // de cate ori se repeta fiecare elem

	b.resize(k); cnt.resize(k);
	n = b.size();


    sc[0] = cnt[0];
    pos[b[0]] = 0;
    for (int i = 1; i < n; ++i)
    {
        if ( pos[b[i]] == -1) // prima aparitie a lui b[i]
            pos[b[i]] = i;
        sc[i] = sc[i - 1] + cnt[i];
    }

    int lasti(-2), p;
	for (int i = 1; i < n; ++i)
	{
		nr[i] = nr[i - 1] + 1;  // nr de modificari pana la poz i in sirul b
		p = pos[b[i]];
        if ( p >= lasti && p < i && sc[i - 1] == sc[p])
            nr[i]--, lasti = i;

        pos[b[i]] = i;
	}

    fout << nr[n - 1] << '\n';
	fout.close();
}

